#!/bin/bash
#
# BACKPACK USB FIRMWARE INSTALLER V .2
#

cat << END_START_MESSAGE
This program will attempt to install the firmware files on a linux system
This will only work if the system has hotplug capability (2.4.18 is the lowest tested kernel)
fxload is also required

(On Redhat systems v8 and beyond, fxload has been integrated
into the hotplug package.)

NOTE: USB2 firmware will not be usable unless the kernel supports USB2 controllers
      (Kernel version 2.4.19 and later)

Press Enter to continue (hit ctrl-c to stop)
END_START_MESSAGE

#Check if root

if [ "$UID" != "0" ]
then
	echo 
        echo "$0:ERROR: This script must be by the root user"
        exit 1
fi

#wait for the return
read JUNK

#See if HOTPLUG directory exists
if [ ! -d /etc/hotplug ]
then
	echo "$0:ERROR: The hotplug system is missing"
	exit 1
fi

#See if the usb directory has already been made
if [ ! -d /etc/hotplug/usb ]
then
	mkdir /etc/hotplug/usb
	if [ $? != 0 ]
	then
		echo "$0:ERROR: Could not create USB directory,, Stoping"
		exit 1
	fi
fi

if [ ! -d /etc/hotplug/usb/bpckusb.fw ]
then
	mkdir /etc/hotplug/usb/bpckusb.fw
	if [ $? != 0 ]
	then
		echo "$0:ERROR: Could not create firmware directory.. Stopping"
		exit 1
	fi
fi


if [ -e /etc/hotplug/usb/bpckusb ]
then 
	echo "$0:ERROR:Previous Install detected.. Stopping."
	exit 1
fi
 
# copy loader script and firmware files
cp bpckusb /etc/hotplug/usb
cp firmware/* /etc/hotplug/usb/bpckusb.fw

#add backpack lines in usb.usermap
cat usb.usermap >> /etc/hotplug/usb.usermap


